=== debian/changelog ===
albert (0.17.2-0~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.
  * Switch to 3.0 (quilt) source format.
  * Add debian/copyright.
  * Clean up formatting in debian/control.
  * debian/rules:
    - enable full hardening.
    - disable automatic dbgsym packages.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Wed, 01 Sep 2021 12:34:16 -0400

albert (0.17.2-0) stable; urgency=low

  * Albert Upstream Release
  
 -- Manuel Schneider <manuelschneid3r@gmail.com>  Sun, 29 Oct 2017 00:00:00 +0000
