=== debian/rules ===
#!/usr/bin/make -f
CODENAME = $(shell lsb_release -cs)
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export QT_SELECT=5


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DBUILD_WITH_QTCHARTS=OFF -DBUILD_VIRTUALBOX=OFF

override_dh_strip:
	dh_strip --no-automatic-dbgsym
