=== plugins/datetime/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
find_package(Albert REQUIRED)

project(datetime VERSION 5.1)

albert_plugin(QT Widgets)
