=== plugins/debug/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
find_package(Albert REQUIRED)

project(debug VERSION 0.0)

albert_plugin(QT Core)
