=== debian/changelog ===
albert (0.24.2-0.1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Use pkgconf for B-D instead of pkg-config.
  * Bump to debhelper-compat 13.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 02 Jul 2024 10:34:50 -0700

albert (0.24.2-0+636.1) stable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Tue, 02 Jul 2024 09:26:37 +0000

albert (0.24.2-0) stable; urgency=low

  * See https://raw.githubusercontent.com/albertlauncher/albert/master/CHANGELOG.md

 -- Manuel Schneider <manuelschneid3r@gmail.com>  Sun, 29 Oct 2017 00:00:00 +0000
