=== debian/control ===
Source: albert
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Manuel Schneider <manuelschneid3r@gmail.com>
Section: utils
Priority: optional
Standards-Version: 4.1.0
Build-Depends: cmake (>=3.19),
               debhelper-compat (= 13),
               libarchive-dev,
               libgl1-mesa-dev,
               libglvnd-dev,
               libqalculate-dev,
               libqt6opengl6-dev,
               libqt6svg6-dev,
               libxml2-utils,
               lsb-release,
               pkgconf,
               python3-dev (>= 3.7),
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-l10n-tools,
               qt6-scxml-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools
Homepage: https://albertlauncher.github.io/
Vcs-Browser: https://github.com/albertlauncher
Vcs-Git: https://github.com/albertlauncher/albert.git

Package: albert
Architecture: any
Depends: libqt6sql6-sqlite,
         python3-pip,
         qml6-module-qt5compat-graphicaleffects,
         qml6-module-qtqml-statemachine,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-shapes,
         qml6-module-qtquick-window,
         qt6-qpa-plugins,
         qt6-wayland,
         ${shlibs:Depends}
Recommends: libqalculate22
Description: Plugin-based C++/Qt keyboard launcher
 Albert is a desktop agnostic keyboard launcher that helps you to accomplish 
 your workflows in a breeze.
