=== debian/rules ===
#!/usr/bin/make -f
CODENAME = $(shell lsb_release -cs)
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export QT_SELECT=6

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -D CMAKE_BUILD_TYPE=Release \ 
	                     -D BUILD_PLUGIN_DEBUG=OFF -Wno-inline 

# No dbgsym packages:
override_dh_strip:
	@echo "not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym
